-- STATUS MONITOR WIFI

background = Image.createEmpty(480, 272)
back_color = Color.new(0,0,255)
text_color = Color.new(255,255,255)
background:clear(back_color)
msg_font = Font.createProportional()
msg_font:setPixelSizes(0,16)

function getNextToken(src,delim)
	if src == delim or src == nil or src == "" then
		return nil,nil
	end
	dist = string.find(src,delim)
	if dist == nil then
		dist = string.len(src)
	else
		dist = dist - 1
	end
	token = string.sub(src,1,dist)
	rem = string.sub(src,dist+1+string.len(delim))
	if rem == delim or rem == nil or rem == "" then
		return token,nil
	end
	return token,rem

end
white = Color.new(255, 255, 255)
offscreen = Image.createEmpty(480, 272)
offscreen:clear(Color.new(0, 0, 0))
y = 0
x = 0

function graphicsPrint(text)
	for i = 1, string.len(text) do
		char = string.sub(text, i, i)
		if char == "\n" then
			y = y + 8
			x = 0
		elseif char ~= "\r" then
			offscreen:print(x, y, char, white)
			x = x + 8
		end
	end
	screen:blit(0, 0, offscreen)
	screen.waitVblankStart()
	screen.flip()
end

function graphicsPrintln(text)
	graphicsPrint(text .. "\n")
end

con_id = 1
connected = 0
serverSocket = 0
ipAddress = ""
while connected == 0 do
	Wlan.init()
	con_id = con_id + 1
	-- init WLAN and choose connection config
	configs = Wlan.getConnectionConfigs()
	graphicsPrintln("available connections:")
	graphicsPrintln("")
	for key, value in ipairs(configs) do
		graphicsPrintln(key .. ": " .. value)
	end
	graphicsPrintln("")
	graphicsPrintln("using connection..."..con_id)
	Wlan.useConnectionConfig(con_id)

	-- start server socket
	graphicsPrintln("open server socket...")
	serverSocket = Socket.createServerSocket(80)

	-- start connection and wait until it is connected
	graphicsPrintln("waiting for WLAN init and determining IP address...")
	timeout = 0
	while timeout < 50 do
		ipAddress = Wlan.getIPAddress()
		if ipAddress then 
			connected = 1
			break 
		end
		System.sleep(100)
		timeout = timeout+1
	end
	graphicsPrintln("timeout:"..timeout.." connected:"..connected)
	if connected == 0 then 
		Wlan.term()
	end
end	
graphicsPrintln("the PSP IP address is: " .. ipAddress)


msg = "Waiting for connection#"..ipAddress
while not Controls.read():start() do
	-- check for incoming requests
	incomingSocket = serverSocket:accept()
	if incomingSocket then
		-- send test page back and close socket
		incomingSocket:send("HTTP/1.0 200 OK\r\nContent-Type: text/plain\r\n\r\n")
		incomingSocket:send("Testpage from your PSP.\r\n")
		msg = ""
		timeout = 300
--		while incomingSocket:isConnected() do
		while timeout > 0 do
			timeout = timeout - 1
			buf = incomingSocket:recv()
			if buf and string.len(buf) > 0 then
				msg = msg..buf
				timeout = 30
			end
			screen.waitVblankStart()
--			if incomingSocket:send(".") < 0 then break end
		end
		incomingSocket:close()
	end
	if string.len(msg) < 1024 then
		img = Image.createEmpty(480, 272)
		img:blit(0, 0, background , 0, 0, background:width(), background:height(), false)
		y = 30
		temp_msg = msg
		while temp_msg do
			line,temp_msg = getNextToken(temp_msg,"#")
			img:fontPrint(msg_font, 30, y, line, text_color)
			y=y+30
		end
	else
		img = Image.loadFromMemory(msg)
	end
	screen:blit(0, 0, img , 0, 0, img:width(), img:height(), false)
	screen.waitVblankStart()
	screen.flip()
end

Wlan.term()
